require 'test/unit'

class TestMyQueue < Test::Unit::TestCase
  def setup
    @queue = MyQueue.new
  end

  def test_empty?
    assert(@queue.empty?, 'a new queue is empty.')
  end

  def test_enq_and_peek
    @queue.enq(3)
    assert_equal(3, @queue.peek, 'peek returns the first value.')
  end

  def test_enq_and_length
    @queue.enq(3)
    assert_equal(1, @queue.length, 'enq increments the length.')
    @queue.enq(5)
    assert_equal(2, @queue.length, 'enq increments the length.')
  end

  def test_enq_and_empty?
    @queue.enq(3)
    assert_equal(false, @queue.empty?, 'a queue with data is not empty.')
  end

  def test_enq_enq_deq_and_length
    @queue.enq(3)
    @queue.enq(5)
    @queue.deq
    assert_equal(1, @queue.length, 'deq decrements the length.')
  end

  def test_enq_enq_deq_and_peek
    @queue.enq(3)
    @queue.enq(5)
    assert_equal(3, @queue.peek, 'peek returns the first value.')
    @queue.deq
    assert_equal(5, @queue.peek, 'peek returns the first value.')
  end

#  def test_undefined_methods
#    assert_raise(NoMethodError) do
#      @queue[1]
#    end
#    assert_raise(NoMethodError) do
#      @queue.last
#    end
#  end

end
